/*******************************************************************************
Copyright © 2024 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

window.TASK = {
    // Aufgabenstellung (HTML erlaubt)
    "task": "Miss die „Batteriespannung“ so exakt wie möglich und trage dein Messergebnis unten ein. Baue den Versuch erst ab, wenn du dazu aufgefordert wirst.",

    // Bedienungshinweise unter Aufgabenstellung (HTML erlaubt)
    "howtouse": "Verbinde Anschlüsse, indem du sie nacheinander anklickst. So kannst du auch vorhandene Verbindungen entfernen. Bediene das Multimeter durch Anklicken der Aufschrift für den gewünschten Messbereich.",

    // Wie viel von 100 Punkten wird pro Fehler abgezogen?
    "fineStep": 10,

    // Messmodi des Multimeters (falls vom Standard abweichend)
    "modes": null,

    // Array of digit information; each digit information is array of indizes of segments
    "digits": [[0], [23, 25, 28, 29, 27, 24, 26, 30], [15, 17, 20, 21, 19, 16, 18, 22], [7, 9, 12, 13, 11, 8, 10, 14], [1, 3, 6, 31, 5, 2, 4]],

    // Interne Bezeichnungen der Anschlüsse
    "connectors": ["Multimeteranschluss 10A⎓", "Multimeteranschluss VΩmA", "Multimeteranschluss COM", "Batterieanschluss +", "unbeschrifteter Batterieanschluss"],

    // Intern verbundene Anschlüsse
    "internalConnected": [["Multimeteranschluss 10A⎓", "Multimeteranschluss VΩmA"]],

    // Anfangs bereits verbundene Anschlüsse
    "connected": [],

    // Zufallswerte
    "randomValues": [
        {
            // Interner Name des Zufallwertes
            "name": "U_Bat",

            // Soll Wert für jede Verwendung neu berechnet werden?
            "floating": false,

            // Welcher Wert aus anderer Quelle (Benutzereingabe, Verbindungen, …) soll übernommen werden?
            "import": "",

            // Erwartungswert der Größe
            "mean": 1.500,

            // Schrittweite der Abweichung
            "step": 0.001,

            // Maximale Abweichung
            "maxdiff": 0.099,

            // Werte statt annähernd gaußförmig linear verteilen?
            "linear": true,

            // Nicht erlaubte Werte
            "exclude": [1.41, 1.42, 1.43, 1.44, 1.45, 1.46, 1.47, 1.48, 1.49, 1.5, 1.51, 1.52, 1.53, 1.54, 1.55, 1.56, 1.57, 1.58, 1.59]
        },
        { "name": "U_open", "floating": true, "mean": 0, "step": 0.0001, "maxdiff": 0.04999 },
        { "name": "input", "import": "input" },
        { "name": "connections", "import": "countConnections" },
        { "name": "gemessen", "import": "display" }
    ],

    // Regeln für die Simulation, die nacheinander abgearbeitet werden
    "simulate": [
        // Einträge werden solange abgearbeitet, wie alle bisherigen erfüllt sind
        [
            {
                // Art der Regel
                "type": "connected",

                // Erwarteter Wert
                "value": "Batterieanschluss +",

                // Ggf. zweiter erwarteter Wert
                "to": "unbeschrifteter Batterieanschluss",

                // Regel invertieren?
                "inverted": false
            },
            { "type": "destroy", "value": "die Batterie" },
            { "type": "return", "value": "false" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_VOLTAGE },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "Multimeteranschluss COM" },
            { "type": "return", "value": "0" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_VOLTAGE },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "Batterieanschluss +" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "return", "value": "U_Bat" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_VOLTAGE },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "Batterieanschluss +" },
            { "type": "return", "value": "-U_Bat" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_VOLTAGE },
            { "type": "return", "value": "U_open" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_CURRENT },
            { "type": "connectedExternal", "value": "Multimeteranschluss 10A⎓", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "Batterieanschluss +" },
            { "type": "destroy", "value": "die Batterie" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_CURRENT },
            { "type": "connectedExternal", "value": "Multimeteranschluss 10A⎓", "to": "Batterieanschluss +" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "destroy", "value": "die Batterie" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_CURRENT },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "Batterieanschluss +" },
            { "type": "destroy", "value": "das Multimeter" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_CURRENT },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "Batterieanschluss +" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "destroy", "value": "das Multimeter" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_CURRENT },
            { "type": "return", "value": "0" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_RESISTANCE },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "Batterieanschluss +" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "destroy", "value": "das Multimeter" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_RESISTANCE },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "unbeschrifteter Batterieanschluss" },
            { "type": "connected", "value": "Multimeteranschluss COM", "to": "Batterieanschluss +" },
            { "type": "destroy", "value": "das Multimeter" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_RESISTANCE },
            { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "Multimeteranschluss COM" },
            { "type": "return", "value": "0" }
        ],
        [
            { "type": "mode", "value": DigitalMultimeter.MEASURE_RESISTANCE },
            { "type": "return", "value": "Infinity" }
        ],
        [
            { "type": "return", "value": false }
        ]
    ],

    // Beschreibung der einzelnen durchzuführenden Messungen
    "levels": [
        {
            "autosubmit": false,
            "html": "Gemessene Spannung: ",
            "input": "text",
            "unit": "",
            "check": [
                [
                    { "type": "mode", "value": DigitalMultimeter.MEASURE_VOLTAGE, "inverted": true  },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Falscher Messbereich" }
                ],
                [
                    { "type": "evaluate", "value": "connections > 2" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Unnötig viele Kabel" }
                ],
                [
                    { "type": "connected", "value": "Multimeteranschluss COM", "to": "Batterieanschluss +" },
                    { "type": "message", "value": "Schließe das Multimeter besser so an, dass du positive Werte erhältst" },
                ],
                [
                    { "type": "connected", "value": "Multimeteranschluss VΩmA", "to": "Batterieanschluss +", "inverted": true },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Verbinde den Batterieanschluss + mit dem Multimeteranschluss VΩmA" }
                ],
                [
                    { "type": "connected", "value": "Multimeteranschluss COM", "to": "unbeschrifteter Batterieanschluss", "inverted": true },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Verbinde den Batterieanschluss - mit dem Multimeteranschluss COM" }
                ],
                [
                    { "type": "connectedExternal", "value": "Multimeteranschluss 10A⎓", "to": "Batterieanschluss +" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Verwende den Multimeteranschluss 10A⎓ nur, wenn wirklich nötig" }
                ],
                [
                    { "type": "unit", "value": "" },
                    { "type": "message", "value": "Gib zuerst deinen Messwert ein", "to": ScoTools.MSGTYPE_INFO }
                ],
                [
                    { "type": "unit", "value": "1", "to": false },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Die Einheit des Messwertes fehlt" }
                ],
                [
                    { "type": "unit", "value": "V", "to": false, "inverted": true },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Die Einheit des Messwertes kann nicht stimmen" }
                ],
                [
                    { "type": "evaluate", "value": "input <> gemessen" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Dein Messwert weicht von der Multimeteranzeige ab" }
                ],
                [
                    { "type": "evaluate", "value": "#input < #gemessen" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Dein Messwert ist unnötigerweise ungenauer als die Multimeteranzeige" }
                ],
                [
                    { "type": "evaluate", "value": "#input > #gemessen" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Dein Messwert ist genauer als die aktuelle Multimeteranzeige" }
                ],
                [
                    { "type": "evaluate", "value": "input <> U_Bat" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Dein Messwert ist falsch" }
                ],
                [
                    { "type": "evaluate", "value": "#input < #U_Bat" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "Dein Messwert ist unnötig ungenau" }
                ],
                [
                    { "type": "evaluate", "value": "#input > #U_Bat" },
                    { "type": "fine", "value": 1 },
                    { "type": "message", "value": "So genau kannst du mit diesem Multimeter nicht messen" }
                ],
                [
                    { "type": "leveldone", "value": true }
                ]
            ]
        },
        {
            "autosubmit": true,
            "html": "Multimeter ausschalten",
            "check": [
                [
                    { "type": "mode", "value": DigitalMultimeter.MEASURE_OFF },
                    { "type": "leveldone", "value": true }
                ]
            ]
        }
    ]
};

window.TASK.svg = '';
